/**
 * Copyright (c) 2011 Generative Software Development Lab, 
 * University of Waterloo, Canada. 
 * All Rights Reserved.
 * ----------------------------------------------------------
 *           \                                                                           
 *            \                                                                          
 *               __                                                                      
 *          w  c(..)o                                                                    
 *           \__(o)                                                                      
 *               /\                                                                      
 *            w_/(_)-~                                                                   
 *                /|                                                                     
 *               | \                                                                     
 *               m  m  
 */
package org.apache.bcel.classfile;

/**
 * The top of an inheritance hierarchy where sub-types can deal
 * with access flags.
 * 
 * The wrapper implements the layered adapter pattern.
 * 
 * @author Thiago Tonelli Bartolomei <ttonelli@uwaterloo.ca>
 */
public abstract class AccessFlags {

	/**
	 * Empty constructor, does nothing.
	 */
	public AccessFlags() {
	}

	/**
	 * Originally implemented by this class.
	 * 
	 * @return
	 */
	public abstract boolean isPublic();

	/**
	 * Originally implemented by this class.
	 *
	 * @param arg0
	 */
	public abstract void setAccessFlags(int arg0);

	/**
	 * Originally implemented by this class.
	 *
	 * @return
	 */
	public abstract int getAccessFlags();
}
