/**
 * Copyright (c) 2011 Generative Software Development Lab, 
 * University of Waterloo, Canada. 
 * All Rights Reserved.
 * ----------------------------------------------------------
 *           \                                                                           
 *            \                                                                          
 *               __                                                                      
 *          w  c(..)o                                                                    
 *           \__(o)                                                                      
 *               /\                                                                      
 *            w_/(_)-~                                                                   
 *                /|                                                                     
 *               | \                                                                     
 *               m  m  
 */
package org.apache.bcel.generic;

import org.apache.bcel.support.WrapperMember;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.TypeInsnNode;


/**
 * 
 * TODO Comment!!
 * 
 * @author Thiago Tonelli Bartolomei <ttonelli@uwaterloo.ca>
 */
public class CHECKCAST extends CPInstruction {

	public CHECKCAST() {
	}

	@WrapperMember
	CHECKCAST(String internalName) {
		setNode(new TypeInsnNode(Opcodes.CHECKCAST, internalName));
	}
	
	/**
	 * Shallow clone of this instruction.
	 *
	 * @return
	 */
	@WrapperMember
	public Instruction cloneInstruction() {
		CHECKCAST cast = new CHECKCAST();
		cast.setNode(this.cloneNode());
		return cast;
	}
	
	@Override
	@WrapperMember
	public AbstractInsnNode cloneNode() {
		return new TypeInsnNode(Opcodes.CHECKCAST, ((TypeInsnNode) getNode()).desc);
	}
}
