/**
 * Copyright (c) 2011 Generative Software Development Lab, 
 * University of Waterloo, Canada. 
 * All Rights Reserved.
 * ----------------------------------------------------------
 *           \                                                                           
 *            \                                                                          
 *               __                                                                      
 *          w  c(..)o                                                                    
 *           \__(o)                                                                      
 *               /\                                                                      
 *            w_/(_)-~                                                                   
 *                /|                                                                     
 *               | \                                                                     
 *               m  m  
 */
package org.apache.bcel.generic;

import org.apache.bcel.classfile.Field;
import org.apache.bcel.support.WrapperMember;
import org.objectweb.asm.tree.FieldNode;


/**
 * 
 * TODO Comment!!
 * 
 * @author Thiago Tonelli Bartolomei <ttonelli@uwaterloo.ca>
 */
public class FieldGen extends FieldGenOrMethodGen {

	/**
	 * Getter allows for wrappee refinement.
	 *
	 * @return
	 */
	@WrapperMember
	protected FieldNode getMemberNode() {
		return (FieldNode) super.getMemberNode();
	}
	
	public FieldGen(int access_flags, Type type, String name, ConstantPoolGen cp) {
		
		// init with a new field node
		FieldNode node = new FieldNode(access_flags, name, type.getType().getDescriptor(), null, null);
		this.setMemberNode(node);
	}

	/**
	 * Creates a field object from this FieldGen.
	 *
	 * @return
	 */
	public Field getField() {
		FieldNode node = getMemberNode();
		return new Field(new FieldNode(node.access, node.name, node.desc, node.signature, node.value));
	}
	
	/**
	 * Originally from super type.
	 *
	 * @return
	 */
	@Override
	public String getName() {
		throw new UnsupportedOperationException();
	}
	
	/**
	 * Originally on super type.
	 *
	 * @return
	 */
	@Override
	public boolean isPublic() {
		throw new UnsupportedOperationException();
	}

	/**
	 * Originally on super type.
	 *
	 * @param arg0
	 */
	@Override
	public void setAccessFlags(int arg0) {
		throw new UnsupportedOperationException();
	}

	/**
	 * Originally on super type.
	 *
	 * @return
	 */
	@Override
	public int getAccessFlags() {
		throw new UnsupportedOperationException();
	}
}
