/**
 * Copyright (c) 2011 Generative Software Development Lab, 
 * University of Waterloo, Canada. 
 * All Rights Reserved.
 * ----------------------------------------------------------
 *           \                                                                           
 *            \                                                                          
 *               __                                                                      
 *          w  c(..)o                                                                    
 *           \__(o)                                                                      
 *               /\                                                                      
 *            w_/(_)-~                                                                   
 *                /|                                                                     
 *               | \                                                                     
 *               m  m  
 */
package org.apache.bcel.generic;

import org.apache.bcel.support.WrapperMember;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.FieldInsnNode;

/**
 * TODO Comment!!
 * 
 * @author Thiago Tonelli Bartolomei <ttonelli@uwaterloo.ca>
 */
public class GETSTATIC extends FieldInstruction {

	@WrapperMember
	GETSTATIC() {}
	
	@WrapperMember
	GETSTATIC(String owner, String name, String desc) {
		setNode(new FieldInsnNode(Opcodes.GETSTATIC, owner, name, desc));
	}
	
	public GETSTATIC(int index) {
		throw new UnsupportedOperationException();
	}
	
	@Override
	Instruction cloneInstruction() {
		GETSTATIC i = new GETSTATIC();
		i.setNode(this.cloneNode());
		return i;
	}

	@Override
	AbstractInsnNode cloneNode() {
		FieldInsnNode node = (FieldInsnNode) this.getNode();
		return new FieldInsnNode(Opcodes.GETSTATIC, node.owner, node.name, node.desc);
	}

}
