/**
 * Copyright (c) 2011 Generative Software Development Lab, 
 * University of Waterloo, Canada. 
 * All Rights Reserved.
 * ----------------------------------------------------------
 *           \                                                                           
 *            \                                                                          
 *               __                                                                      
 *          w  c(..)o                                                                    
 *           \__(o)                                                                      
 *               /\                                                                      
 *            w_/(_)-~                                                                   
 *                /|                                                                     
 *               | \                                                                     
 *               m  m  
 */
package org.apache.bcel.generic;

import org.apache.bcel.support.WrapperMember;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.VarInsnNode;

/**
 * 
 * TODO Comment!!
 * 
 * @author Thiago Tonelli Bartolomei <ttonelli@uwaterloo.ca>
 */
public class ILOAD extends LoadInstruction {

	@WrapperMember
	ILOAD() {}
	
	/**
	 * Creates an instruction to load the variable var as an int.
	 *
	 * @param var
	 */
	public ILOAD(int var) {
		setNode(new VarInsnNode(Opcodes.ILOAD, var));
	}
	
	/**
	 * Shallow clone of this instruction.
	 *
	 * @return
	 */
	@WrapperMember
	public Instruction cloneInstruction() {
		return new ILOAD(((VarInsnNode) getNode()).var);
	}
	
	@Override
	@WrapperMember
	public AbstractInsnNode cloneNode() {
		return new VarInsnNode(Opcodes.ILOAD, ((VarInsnNode) getNode()).var);
	}
}
