/**
 * Copyright (c) 2011 Generative Software Development Lab, 
 * University of Waterloo, Canada. 
 * All Rights Reserved.
 * ----------------------------------------------------------
 *           \                                                                           
 *            \                                                                          
 *               __                                                                      
 *          w  c(..)o                                                                    
 *           \__(o)                                                                      
 *               /\                                                                      
 *            w_/(_)-~                                                                   
 *                /|                                                                     
 *               | \                                                                     
 *               m  m  
 */
package org.apache.bcel.generic;

import org.apache.bcel.support.WrapperMember;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.MethodInsnNode;


/**
 * TODO Comment!!
 * 
 * @author Thiago Tonelli Bartolomei <ttonelli@uwaterloo.ca>
 */
public class INVOKEINTERFACE extends InvokeInstruction {

	@WrapperMember
	INVOKEINTERFACE() {}
	
	@WrapperMember
	INVOKEINTERFACE(String owner, String name, String desc) {
		setNode(new MethodInsnNode(Opcodes.INVOKEINTERFACE, owner, name, desc));
	}
	
	/**
	 * Shallow clone of this instruction.
	 *
	 * @return
	 */
	@WrapperMember
	public Instruction cloneInstruction() {
		MethodInsnNode node = (MethodInsnNode) getNode();
		return new INVOKEINTERFACE(node.owner, node.name, node.desc);
	}
	
	@Override
	@WrapperMember
	public AbstractInsnNode cloneNode() {
		MethodInsnNode node = (MethodInsnNode) getNode();
		return new MethodInsnNode(Opcodes.INVOKEINTERFACE, node.owner, node.name, node.desc);
	}
}