/**
 * Copyright (c) 2011 Generative Software Development Lab, 
 * University of Waterloo, Canada. 
 * All Rights Reserved.
 * ----------------------------------------------------------
 *           \                                                                           
 *            \                                                                          
 *               __                                                                      
 *          w  c(..)o                                                                    
 *           \__(o)                                                                      
 *               /\                                                                      
 *            w_/(_)-~                                                                   
 *                /|                                                                     
 *               | \                                                                     
 *               m  m  
 */
package org.apache.bcel.generic;

import org.apache.bcel.support.WrapperMember;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.IntInsnNode;


/**
 * 
 * TODO Comment!!
 * 
 * @author Thiago Tonelli Bartolomei <ttonelli@uwaterloo.ca>
 */
public class NEWARRAY extends org.apache.bcel.generic.Instruction {

	@WrapperMember
	NEWARRAY() {
	}
	
	protected static int[] SORT_TYPE = new int[11]; 
	static {
		SORT_TYPE[org.objectweb.asm.Type.BOOLEAN] = Opcodes.T_BOOLEAN;
		SORT_TYPE[org.objectweb.asm.Type.CHAR]    = Opcodes.T_CHAR;
		SORT_TYPE[org.objectweb.asm.Type.FLOAT]   = Opcodes.T_FLOAT;
		SORT_TYPE[org.objectweb.asm.Type.DOUBLE]  = Opcodes.T_DOUBLE;
		SORT_TYPE[org.objectweb.asm.Type.BYTE]    = Opcodes.T_BYTE;
		SORT_TYPE[org.objectweb.asm.Type.SHORT]   = Opcodes.T_SHORT;
		SORT_TYPE[org.objectweb.asm.Type.INT]     = Opcodes.T_INT;
		SORT_TYPE[org.objectweb.asm.Type.LONG]    = Opcodes.T_LONG;
	}
    
	public NEWARRAY(BasicType type) {
		this.setNode(new IntInsnNode(Opcodes.NEWARRAY, SORT_TYPE[type.getType().getSort()]));
	}
	
	/** 
	 * Clones this instruction.
	 *
	 * @return
	 */
	@Override
	@WrapperMember
	public Instruction cloneInstruction() {
		NEWARRAY i = new NEWARRAY(null);
		i.setNode(this.cloneNode());
		return i;
	}
	
	@Override
	@WrapperMember
	public AbstractInsnNode cloneNode() {
		throw new UnsupportedOperationException();
	}
}
