/**
 * Copyright (c) 2011 Generative Software Development Lab, 
 * University of Waterloo, Canada. 
 * All Rights Reserved.
 * ----------------------------------------------------------
 *           \                                                                           
 *            \                                                                          
 *               __                                                                      
 *          w  c(..)o                                                                    
 *           \__(o)                                                                      
 *               /\                                                                      
 *            w_/(_)-~                                                                   
 *                /|                                                                     
 *               | \                                                                     
 *               m  m  
 */
package org.apache.bcel.generic;

import org.apache.bcel.Constants;
import org.apache.bcel.support.WrapperMember;

/**
 * 
 * TODO Comment!!
 * 
 * @author Thiago Tonelli Bartolomei <ttonelli@uwaterloo.ca>
 */
public final class PUSH implements CompoundInstruction, InstructionConstants {

	@WrapperMember
    protected Instruction instruction = null;
	
	@WrapperMember
	PUSH() {}
	
	public PUSH(ConstantPoolGen cp, String value) {
		if (null == value) {
            instruction = ACONST_NULL;
        } else {
            instruction = new LDC(value);
        }
	}

	public PUSH(ConstantPoolGen cp, int value) {

		if ((value >= -1) && (value <= 5)) {
			instruction = INSTRUCTIONS[Constants.ICONST_0 + value];
			
		} else if ((value >= -128) && (value <= 127)) {
			instruction = new BIPUSH((byte) value);
			
		} else if ((value >= -32768) && (value <= 32767)) {
			instruction = new SIPUSH((short) value);
			
		} else {
			instruction = new LDC(new Integer(value));
		}
	}
	
	public final InstructionList getInstructionList() {
        return new InstructionList(instruction);
    }
}
