/**
 * Copyright (c) 2011 Generative Software Development Lab, 
 * University of Waterloo, Canada. 
 * All Rights Reserved.
 * ----------------------------------------------------------
 *           \                                                                           
 *            \                                                                          
 *               __                                                                      
 *          w  c(..)o                                                                    
 *           \__(o)                                                                      
 *               /\                                                                      
 *            w_/(_)-~                                                                   
 *                /|                                                                     
 *               | \                                                                     
 *               m  m  
 */
package org.apache.bcel.generic;

import org.apache.bcel.support.WrapperMember;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.InsnNode;


/**
 * 
 * TODO Comment!!
 * 
 * @author Thiago Tonelli Bartolomei <ttonelli@uwaterloo.ca>
 */
public class RETURN extends ReturnInstruction {

	public RETURN() {
		super(new InsnNode(Opcodes.RETURN));
	}
	
	/** 
	 * Clones this instruction.
	 *
	 * @return
	 */
	@Override
	@WrapperMember
	public Instruction cloneInstruction() {
		return new RETURN();
	}
	
	@Override
	@WrapperMember
	public AbstractInsnNode cloneNode() {
		return new InsnNode(Opcodes.RETURN);
	}
}
